# remirepo/Fedora spec file for php-zendframework-zend-db
#
# Copyright (c) 2015-2018 Remi Collet
# License: CC-BY-SA
# http://creativecommons.org/licenses/by-sa/4.0/
#
# Please, preserve the changelog entries
#
%global bootstrap    0
%global gh_commit    5b4f2c42f94c9f7f4b2f456a0ebe459fab12b3d9
%global gh_short     %(c=%{gh_commit}; echo ${c:0:7})
%global gh_owner     zendframework
%global gh_project   zend-db
%global php_home     %{_datadir}/php
%global library      Db
%if %{bootstrap}
%global with_tests   0%{?_with_tests:1}
%else
%global with_tests   0%{!?_without_tests:1}
%endif

# TODO: cannot use phpunit6 for now
# PHP Fatal error:  Declaration of ZendTest\Db\IntegrationTestListener::addError(PHPUnit_Framework_Test $test, Exception $e, $time)
# must be compatible with PHPUnit\Framework\TestListener::addError(PHPUnit\Framework\Test $test, Exception $e, $time) ...

Name:           php-%{gh_owner}-%{gh_project}
Version:        2.9.3
Release:        1%{?dist}
Summary:        Zend Framework %{library} component

Group:          Development/Libraries
License:        BSD
URL:            https://zendframework.github.io/%{gh_project}/
Source0:        %{gh_commit}/%{name}-%{version}-%{gh_short}.tgz
Source1:        makesrc.sh

BuildArch:      noarch
# Tests
%if %{with_tests}
BuildRequires:  php(language) >= 5.6
BuildRequires:  php-date
BuildRequires:  php-pcre
BuildRequires:  php-pdo
BuildRequires:  php-spl
BuildRequires:  php-composer(%{gh_owner}/zend-stdlib)           >= 2.7
# From composer, "require-dev": {
#        "phpunit/phpunit": "^5.7.25 || ^6.4.4",
#        "zendframework/zend-coding-standard": "~1.0.0",
#        "zendframework/zend-eventmanager": "^2.6.2 || ^3.0",
#        "zendframework/zend-hydrator": ""^1.1 || ^2.1",
#        "zendframework/zend-servicemanager": "^2.7.5 || ^3.0.3"
BuildRequires:  php-composer(%{gh_owner}/zend-eventmanager)     >= 2.6.2
BuildRequires:  php-composer(%{gh_owner}/zend-hydrator)         >= 1.1
BuildRequires:  php-composer(%{gh_owner}/zend-servicemanager)   >= 2.7.5
%if 0%{?fedora} >= 26
%global phpunit %{_bindir}/phpunit6
BuildRequires:  phpunit6 >= 6.4.4
%else
%global phpunit %{_bindir}/phpunit
BuildRequires:  php-phpunit-PHPUnit >= 5.7.25
%endif
# Autoloader
BuildRequires:  php-composer(%{gh_owner}/zend-loader)           >= 2.5
%endif

# From composer, "require": {
#        "php": "^5.6 || ^7.0",
#        "zendframework/zend-stdlib": "^2.7 || ^3.0"
Requires:       php(language) >= 5.6
%if ! %{bootstrap}
Requires:       php-composer(%{gh_owner}/zend-stdlib)           >= 2.7
Requires:       php-composer(%{gh_owner}/zend-stdlib)           <  4
# From composer, "suggest": {
#        "zendframework/zend-eventmanager": "Zend\\EventManager component",
#        "zendframework/zend-servicemanager": "Zend\\ServiceManager component"
%if 0%{?fedora} >= 21
Suggests:       php-composer(%{gh_owner}/zend-eventmanager)
Suggests:       php-composer(%{gh_owner}/zend-hydrator)
Suggests:       php-composer(%{gh_owner}/zend-servicemanager)
%endif
%endif
# From phpcompatinfo report for version 2.6.2
Requires:       php-date
Requires:       php-pcre
Requires:       php-pdo
Requires:       php-spl

Obsoletes:      php-ZendFramework2-%{library} < 2.5
Provides:       php-ZendFramework2-%{library} = %{version}
Provides:       php-composer(%{gh_owner}/%{gh_project}) = %{version}


%description
Zend\Db is a component that abstract the access to a Database using an object
oriented API to build the queries. Zend\Db consumes different storage adapters
to access different database vendors such as MySQL, PostgreSQL, Oracle,
IBM DB2, Microsoft Sql Server, PDO, etc.

Documentation: https://zendframework.github.io/%{gh_project}/


%prep
%setup -q -n %{gh_project}-%{gh_commit}

mv LICENSE.md LICENSE


%build
# Empty build section, nothing required


%install
mkdir -p   %{buildroot}%{php_home}/Zend/
cp -pr src %{buildroot}%{php_home}/Zend/%{library}


%check
%if %{with_tests}
mkdir vendor
cat << 'EOF' | tee vendor/autoload.php
<?php
# comptibility layer before PSR-0 autoloader
require_once dirname(__DIR__) . '/test/autoload.php';
require_once '%{php_home}/Zend/Loader/AutoloaderFactory.php';
Zend\Loader\AutoloaderFactory::factory(array(
    'Zend\Loader\StandardAutoloader' => array(
        'namespaces' => array(
           'ZendTest\\%{library}' => dirname(__DIR__).'/test/unit/',
           'ZendIntegrationTest\\%{library}' => dirname(__DIR__).'/test/integration/',
           'Zend\\%{library}'     => '%{buildroot}%{php_home}/Zend/%{library}'
))));
require_once '%{php_home}/Zend/autoload.php';
EOF

ret=0
for cmdarg in "php %{phpunit}" php70 php71 php72; do
  if which $cmdarg; then
    set $cmdarg
    $1 ${2:-%{_bindir}/phpunit6} --verbose || ret=1
  fi
done
exit $ret
%else
: Test suite disabled
%endif


%files
%{!?_licensedir:%global license %%doc}
%license LICENSE
%doc *.md
%doc composer.json
%{php_home}/Zend/%{library}


%changelog
* Wed Apr 11 2018 Remi Collet <remi@remirepo.net> - 2.9.3-1
- update to 2.9.3

* Tue Dec 12 2017 Remi Collet <remi@remirepo.net> - 2.9.2-1
- Update to 2.9.2

* Fri Dec  8 2017 Remi Collet <remi@remirepo.net> - 2.9.1-1
- Update to 2.9.1

* Thu Dec  7 2017 Remi Collet <remi@remirepo.net> - 2.9.0-2
- use phpunit6 on F26+

* Thu Dec  7 2017 Remi Collet <remi@remirepo.net> - 2.9.0-1
- Update to 2.9.0
- raise dependency on PHP 5.6

* Tue Oct 31 2017 Remi Collet <remi@fedoraproject.org> - 2.8.2-4
- fix FTBFS from Koschei, add patch for PHP 7.2
  from https://github.com/zendframework/zend-db/pull/276

* Thu Jul 27 2017 Fedora Release Engineering <releng@fedoraproject.org> - 2.8.2-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 2.8.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Wed Aug 10 2016 Remi Collet <remi@fedoraproject.org> - 2.8.2-1
- update to 2.8.2

* Thu Apr 14 2016 Remi Collet <remi@fedoraproject.org> - 2.8.1-1
- update to 2.8.1

* Wed Apr 13 2016 Remi Collet <remi@fedoraproject.org> - 2.8.0-1
- update to 2.8.0

* Tue Feb 23 2016 Remi Collet <remi@fedoraproject.org> - 2.7.0-1
- update to 2.7.0

* Thu Feb 04 2016 Fedora Release Engineering <releng@fedoraproject.org> - 2.6.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Thu Jan 28 2016 Remi Collet <remi@fedoraproject.org> - 2.6.2-1
- update to 2.6.2
- rasie dependency on zend-stdlib ~2.7
- add optional dependency on zend-hydrator

* Thu Oct  1 2015 Remi Collet <remi@fedoraproject.org> - 2.5.2-1
- normal build

* Wed Sep 23 2015 Remi Collet <remi@fedoraproject.org> - 2.5.2-0
- update to 2.5.2, bootstrap build
- raise dependency on php 5.5

* Tue Aug  4 2015 Remi Collet <remi@fedoraproject.org> - 2.5.1-1
- initial package